## tremotesf 2.4.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2023 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

if (WIN32)
    cmake_minimum_required(VERSION 3.21)
else()
    cmake_minimum_required(VERSION 3.16)
endif()
cmake_policy(VERSION ${CMAKE_MINIMUM_REQUIRED_VERSION}..3.26)

project(tremotesf VERSION 2.4.0 LANGUAGES CXX)

include(CTest)
include(GNUInstallDirs)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(TREMOTESF_QT6 OFF CACHE BOOL "Build with Qt 6" FORCE)
include(src/libtremotesf/cmake/CommonOptions.cmake)

find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Core)

set(QRC_FILES "")
add_subdirectory("data")
add_subdirectory("translations")
add_subdirectory("src")
if (WIN32)
    add_subdirectory("windows-packaging")
endif()

=== data/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2023 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

list(
    APPEND QRC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/icons/status/status.qrc"
)

if (TREMOTESF_UNIX_FREEDESKTOP)
    find_package(Gettext 0.19.7 REQUIRED)

    install(DIRECTORY "icons/hicolor" DESTINATION "${CMAKE_INSTALL_DATADIR}/icons")

    set(po_dir "${CMAKE_CURRENT_SOURCE_DIR}/po")

    set(desktop_file_template "${CMAKE_CURRENT_SOURCE_DIR}/org.equeim.Tremotesf.desktop.in")
    set(desktop_file_path "${CMAKE_CURRENT_BINARY_DIR}/org.equeim.Tremotesf.desktop")
    add_custom_command(
        OUTPUT "${desktop_file_path}"
        COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}"
        ARGS --desktop -d "${po_dir}" --template "${desktop_file_template}" -o "${desktop_file_path}"
        DEPENDS "${desktop_file_template}"
        VERBATIM
    )
    add_custom_target(desktop_file ALL DEPENDS "${desktop_file_path}")
    install(FILES "${desktop_file_path}" DESTINATION "${CMAKE_INSTALL_DATADIR}/applications")

    set(appdata_template "${CMAKE_CURRENT_SOURCE_DIR}/org.equeim.Tremotesf.appdata.xml.in")
    set(appdata_path "${CMAKE_CURRENT_BINARY_DIR}/org.equeim.Tremotesf.appdata.xml")
    add_custom_command(
        OUTPUT "${appdata_path}"
        COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}"
        ARGS --xml -d "${po_dir}" --template "${appdata_template}" -o "${appdata_path}"
        DEPENDS "${appdata_template}"
        VERBATIM
    )
    add_custom_target(appdata ALL DEPENDS "${appdata_path}")
    install(FILES "${appdata_path}" DESTINATION "${CMAKE_INSTALL_DATADIR}/metainfo")
elseif (WIN32)
    set(TREMOTESF_BUNDLED_ICONS_DIR "icons")
    set(TREMOTESF_BUNDLED_ICONS_DIR ${TREMOTESF_BUNDLED_ICONS_DIR} PARENT_SCOPE)

    set(TREMOTESF_BUNDLED_ICON_THEME "breeze")
    set(TREMOTESF_BUNDLED_ICON_THEME ${TREMOTESF_BUNDLED_ICON_THEME} PARENT_SCOPE)

    install(DIRECTORY "icons/hicolor" DESTINATION "${TREMOTESF_BUNDLED_ICONS_DIR}")

    if (WIN32)
        message(STATUS "Building for Windows, deploying icon themes")

        include(FetchContent)

        cmake_policy(SET CMP0135 NEW)
        set(FETCHCONTENT_QUIET OFF)

        FetchContent_Declare(
            hicolor_icon_theme
            URL "https://icon-theme.freedesktop.org/releases/hicolor-icon-theme-0.17.tar.xz"
            URL_HASH SHA256=317484352271d18cbbcfac3868eab798d67fff1b8402e740baa6ff41d588a9d8
        )
        FetchContent_Populate(hicolor_icon_theme)
        install(FILES "${hicolor_icon_theme_SOURCE_DIR}/index.theme" DESTINATION "${TREMOTESF_BUNDLED_ICONS_DIR}/hicolor")

        FetchContent_Declare(
            breeze_icons
            URL "https://download.kde.org/stable/frameworks/5.104/breeze-icons-5.104.0.zip"
            URL_HASH SHA256=b4ea76a5737ca48abd61e0cee2c54cceb8bf3d3bd6f5d15f1f740c5c7432e60c
        )
        FetchContent_Populate(breeze_icons)

        # Keep in sync with QIcon::fromTheme() calls in source code
        set(bundled_icon_theme_files
            index.theme
            application-exit.svg
            applications-utilities.svg
            configure.svg
            dialog-cancel.svg
            dialog-error.svg
            document-open.svg
            document-preview.svg
            document-properties.svg
            download.svg
            edit-copy.svg
            edit-delete.svg
            edit-delete.svg
            edit-rename.svg
            edit-select-all.svg
            edit-select-invert.svg
            folder-download.svg
            go-bottom.svg
            go-down.svg
            go-jump.svg
            go-top.svg
            go-up.svg
            help-about.svg
            insert-link.svg
            list-add.svg
            list-remove.svg
            mark-location.svg
            media-playback-pause.svg
            media-playback-start.svg
            network-connect.svg
            network-disconnect.svg
            network-server.svg
            network-server.svg
            preferences-system.svg
            preferences-system-network.svg
            preferences-system-time.svg
            system-shutdown.svg
            view-refresh.svg
            view-refresh.svg
            view-statistics.svg
            window-close.svg
        )

        list(JOIN bundled_icon_theme_files "|" bundled_icon_theme_files_regex)
        string(REPLACE "." "\\." bundled_icon_theme_files_regex "${bundled_icon_theme_files_regex}")
        string(PREPEND bundled_icon_theme_files_regex "^.*\\/(")
        string(APPEND bundled_icon_theme_files_regex ")$")

        install(DIRECTORY "${breeze_icons_SOURCE_DIR}/icons/" DESTINATION "${TREMOTESF_BUNDLED_ICONS_DIR}/breeze" FILES_MATCHING REGEX "${bundled_icon_theme_files_regex}")
    endif()
endif()

set(QRC_FILES ${QRC_FILES} PARENT_SCOPE)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2023 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

add_subdirectory(libtremotesf)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(TREMOTESF_COMMON_TARGET_PROPERTIES AUTOMOC ON AUTORCC ON)

find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Concurrent Network Widgets)
find_package(KF5WidgetsAddons REQUIRED)
find_package(cxxopts REQUIRED)
find_package(Threads REQUIRED)

list(APPEND QRC_FILES tremotesf/resources.qrc)

add_executable(
    tremotesf

    tremotesf/bencodeparser.cpp
    tremotesf/bencodeparser.h
    tremotesf/desktoputils.cpp
    tremotesf/desktoputils.h
    tremotesf/filemanagerlauncher.cpp
    tremotesf/filemanagerlauncher.h
    tremotesf/settings.cpp
    tremotesf/settings.h
    tremotesf/utils.cpp
    tremotesf/utils.h
    tremotesf/ipc/ipcclient.h
    tremotesf/ipc/ipcserver.h
    tremotesf/rpc/servers.cpp
    tremotesf/rpc/servers.h
    tremotesf/rpc/trpc.cpp
    tremotesf/rpc/trpc.h
    tremotesf/startup/commandlineparser.cpp
    tremotesf/startup/commandlineparser.h
    tremotesf/startup/main.cpp
    tremotesf/startup/signalhandler.h
    tremotesf/ui/darkthemeapplier.h
    tremotesf/ui/notificationscontroller.cpp
    tremotesf/ui/notificationscontroller.h
    tremotesf/ui/systemcolorsprovider.h
    tremotesf/ui/itemmodels/baseproxymodel.cpp
    tremotesf/ui/itemmodels/baseproxymodel.h
    tremotesf/ui/itemmodels/basetorrentfilesmodel.cpp
    tremotesf/ui/itemmodels/basetorrentfilesmodel.h
    tremotesf/ui/itemmodels/modelutils.h
    tremotesf/ui/itemmodels/stringlistmodel.cpp
    tremotesf/ui/itemmodels/stringlistmodel.h
    tremotesf/ui/itemmodels/torrentfilesmodelentry.cpp
    tremotesf/ui/itemmodels/torrentfilesmodelentry.h
    tremotesf/ui/itemmodels/torrentfilesproxymodel.cpp
    tremotesf/ui/itemmodels/torrentfilesproxymodel.h
    tremotesf/ui/screens/aboutdialog.cpp
    tremotesf/ui/screens/aboutdialog.h
    tremotesf/ui/screens/serverstatsdialog.cpp
    tremotesf/ui/screens/serverstatsdialog.h
    tremotesf/ui/screens/settingsdialog.cpp
    tremotesf/ui/screens/settingsdialog.h
    tremotesf/ui/screens/addtorrent/addtorrentdialog.cpp
    tremotesf/ui/screens/addtorrent/addtorrentdialog.h
    tremotesf/ui/screens/addtorrent/droppedtorrents.cpp
    tremotesf/ui/screens/addtorrent/droppedtorrents.h
    tremotesf/ui/screens/addtorrent/localtorrentfilesmodel.cpp
    tremotesf/ui/screens/addtorrent/localtorrentfilesmodel.h
    tremotesf/ui/screens/connectionsettings/connectionsettingsdialog.cpp
    tremotesf/ui/screens/connectionsettings/connectionsettingsdialog.h
    tremotesf/ui/screens/connectionsettings/servereditdialog.cpp
    tremotesf/ui/screens/connectionsettings/servereditdialog.h
    tremotesf/ui/screens/connectionsettings/serversmodel.cpp
    tremotesf/ui/screens/connectionsettings/serversmodel.h
    tremotesf/ui/screens/mainwindow/alltrackersmodel.cpp
    tremotesf/ui/screens/mainwindow/alltrackersmodel.h
    tremotesf/ui/screens/mainwindow/basetorrentsfilterssettingsmodel.cpp
    tremotesf/ui/screens/mainwindow/basetorrentsfilterssettingsmodel.h
    tremotesf/ui/screens/mainwindow/downloaddirectoriesmodel.cpp
    tremotesf/ui/screens/mainwindow/downloaddirectoriesmodel.h
    tremotesf/ui/screens/mainwindow/mainwindow.cpp
    tremotesf/ui/screens/mainwindow/mainwindow.h
    tremotesf/ui/screens/mainwindow/mainwindowsidebar.cpp
    tremotesf/ui/screens/mainwindow/mainwindowsidebar.h
    tremotesf/ui/screens/mainwindow/mainwindowstatusbar.cpp
    tremotesf/ui/screens/mainwindow/mainwindowstatusbar.h
    tremotesf/ui/screens/mainwindow/mainwindowviewmodel.cpp
    tremotesf/ui/screens/mainwindow/mainwindowviewmodel.h
    tremotesf/ui/screens/mainwindow/statusfiltersmodel.cpp
    tremotesf/ui/screens/mainwindow/statusfiltersmodel.h
    tremotesf/ui/screens/mainwindow/torrentsmodel.cpp
    tremotesf/ui/screens/mainwindow/torrentsmodel.h
    tremotesf/ui/screens/mainwindow/torrentsproxymodel.cpp
    tremotesf/ui/screens/mainwindow/torrentsproxymodel.h
    tremotesf/ui/screens/mainwindow/torrentsview.cpp
    tremotesf/ui/screens/mainwindow/torrentsview.h
    tremotesf/ui/screens/serversettings/serversettingsdialog.cpp
    tremotesf/ui/screens/serversettings/serversettingsdialog.h
    tremotesf/ui/screens/torrentproperties/peersmodel.cpp
    tremotesf/ui/screens/torrentproperties/peersmodel.h
    tremotesf/ui/screens/torrentproperties/torrentfilesmodel.cpp
    tremotesf/ui/screens/torrentproperties/torrentfilesmodel.h
    tremotesf/ui/screens/torrentproperties/torrentpropertiesdialog.cpp
    tremotesf/ui/screens/torrentproperties/torrentpropertiesdialog.h
    tremotesf/ui/screens/torrentproperties/trackersmodel.cpp
    tremotesf/ui/screens/torrentproperties/trackersmodel.h
    tremotesf/ui/screens/torrentproperties/trackersviewwidget.cpp
    tremotesf/ui/screens/torrentproperties/trackersviewwidget.h
    tremotesf/ui/widgets/basetreeview.cpp
    tremotesf/ui/widgets/basetreeview.h
    tremotesf/ui/widgets/commondelegate.cpp
    tremotesf/ui/widgets/commondelegate.h
    tremotesf/ui/widgets/remotedirectoryselectionwidget.cpp
    tremotesf/ui/widgets/remotedirectoryselectionwidget.h
    tremotesf/ui/widgets/textinputdialog.cpp
    tremotesf/ui/widgets/textinputdialog.h
    tremotesf/ui/widgets/torrentfilesview.cpp
    tremotesf/ui/widgets/torrentfilesview.h
    tremotesf/ui/widgets/torrentremotedirectoryselectionwidget.cpp
    tremotesf/ui/widgets/torrentremotedirectoryselectionwidget.h
    ${QRC_FILES}
)

target_link_libraries(tremotesf PRIVATE libtremotesf Qt::Network Qt::Widgets KF5::WidgetsAddons cxxopts::cxxopts Threads::Threads)

target_include_directories(tremotesf PRIVATE ${Qt${TREMOTESF_QT_VERSION_MAJOR}Concurrent_INCLUDE_DIRS})
target_compile_definitions(
    tremotesf PRIVATE
    TREMOTESF_EXECUTABLE_NAME="tremotesf"
    TREMOTESF_APP_ID="org.equeim.Tremotesf"
    TREMOTESF_APP_NAME="Tremotesf"
    TREMOTESF_VERSION="${PROJECT_VERSION}"
    TREMOTESF_QT_TRANSLATIONS_FILENAME="${TREMOTESF_QT_TRANSLATIONS_FILENAME}"
)

if (TREMOTESF_UNIX_FREEDESKTOP)
    find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS DBus)
    find_package(KF5WindowSystem REQUIRED)
    target_link_libraries(tremotesf PRIVATE Qt::DBus KF5::WindowSystem)

    target_compile_definitions(
        tremotesf PRIVATE
        TREMOTESF_BUNDLED_ICONS_DIR=""
        TREMOTESF_BUNDLED_ICON_THEME=""
        TREMOTESF_BUNDLED_QT_TRANSLATIONS_DIR=""
    )

    qt_add_dbus_adaptor(
        dbus_generated
        tremotesf/ipc/org.freedesktop.Application.xml
        tremotesf/ipc/ipcserver_dbus_service.h
        tremotesf::IpcDbusService
        tremotesf_dbus_generated/ipc/org.freedesktop.Application.adaptor
        OrgFreedesktopApplicationAdaptor
    )
    qt_add_dbus_interface(
        dbus_generated
        tremotesf/ipc/org.freedesktop.Application.xml
        tremotesf_dbus_generated/ipc/org.freedesktop.Application
    )
    qt_add_dbus_interface(
        dbus_generated
        tremotesf/org.freedesktop.Notifications.xml
        tremotesf_dbus_generated/org.freedesktop.Notifications
    )
    qt_add_dbus_interface(
        dbus_generated
        tremotesf/org.freedesktop.FileManager1.xml
        tremotesf_dbus_generated/org.freedesktop.FileManager1
    )

    target_sources(
        tremotesf PRIVATE
        tremotesf/filemanagerlauncher_freedesktop.cpp
        tremotesf/unixhelpers.cpp
        tremotesf/unixhelpers.h
        tremotesf/ipc/ipcclient_dbus.cpp
        tremotesf/ipc/ipcserver_dbus_service.cpp
        tremotesf/ipc/ipcserver_dbus_service.h
        tremotesf/ipc/ipcserver_dbus.cpp
        tremotesf/ipc/ipcserver_dbus.h
        tremotesf/startup/signalhandler_unix.cpp
        tremotesf/ui/darkthemeapplier_noop.cpp
        tremotesf/ui/notificationscontroller_freedesktop.cpp
        tremotesf/ui/systemcolorsprovider_noop.cpp
        ${dbus_generated}
    )
elseif (WIN32)
    find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Svg)
    find_library(Dwmapi Dwmapi REQUIRED)
    target_link_libraries(tremotesf PRIVATE Qt::Svg "${Dwmapi}")
    target_sources(
        tremotesf PRIVATE
        tremotesf/filemanagerlauncher_windows.cpp
        tremotesf/windowshelpers.cpp
        tremotesf/windowshelpers.h
        tremotesf/ipc/ipcclient_socket.cpp
        tremotesf/ipc/ipcserver_socket.cpp
        tremotesf/ipc/ipcserver_socket.h
        tremotesf/startup/main_windows.cpp
        tremotesf/startup/main_windows.h
        tremotesf/startup/signalhandler_windows.cpp
        tremotesf/startup/windowsmessagehandler.cpp
        tremotesf/startup/windowsmessagehandler.h
        tremotesf/ui/darkthemeapplier_windows.cpp
        tremotesf/ui/notificationscontroller_fallback.cpp
        tremotesf/ui/recoloringsvgiconengine.cpp
        tremotesf/ui/recoloringsvgiconengine.h
        tremotesf/ui/systemcolorsprovider_windows.cpp
        tremotesf/tremotesf.rc
    )
    set(
        rc_definitions
        TREMOTESF_VERSION_MAJOR=${PROJECT_VERSION_MAJOR}
        TREMOTESF_VERSION_MINOR=${PROJECT_VERSION_MINOR}
        TREMOTESF_VERSION_PATCH=${PROJECT_VERSION_PATCH}
    )
    set_source_files_properties(
        tremotesf/tremotesf.rc
        PROPERTIES COMPILE_DEFINITIONS "${rc_definitions}"
    )
    if (MSVC)
        target_sources(
            tremotesf PRIVATE
            tremotesf/tremotesf.manifest
        )
    else()
        target_sources(
            tremotesf PRIVATE
            tremotesf/tremotesf.manifest.rc
        )
    endif()

    set(TREMOTESF_WINDOWS_ICON "${CMAKE_CURRENT_SOURCE_DIR}/tremotesf/tremotesf.ico" PARENT_SCOPE)
    target_compile_definitions(tremotesf PRIVATE
        TREMOTESF_BUNDLED_ICONS_DIR="${TREMOTESF_BUNDLED_ICONS_DIR}"
        TREMOTESF_BUNDLED_ICON_THEME="${TREMOTESF_BUNDLED_ICON_THEME}"
        TREMOTESF_BUNDLED_QT_TRANSLATIONS_DIR="${TREMOTESF_BUNDLED_QT_TRANSLATIONS_DIR}"
        QT_STATICPLUGIN
    )

    set_target_properties(tremotesf PROPERTIES WIN32_EXECUTABLE $<NOT:$<CONFIG:Debug>>)

    qt_import_plugins(
        tremotesf
        EXCLUDE_BY_TYPE bearer iconengines imageformats styles
    )
else()
    target_compile_definitions(
        tremotesf PRIVATE
        TREMOTESF_BUNDLED_ICONS_DIR=""
        TREMOTESF_BUNDLED_ICON_THEME=""
        TREMOTESF_BUNDLED_QT_TRANSLATIONS_DIR=""
    )
    target_sources(
        tremotesf PRIVATE
        tremotesf/filemanagerlauncher_fallback.cpp
        tremotesf/unixhelpers.cpp
        tremotesf/unixhelpers.h
        tremotesf/ipc/ipcclient_socket.cpp
        tremotesf/ipc/ipcserver_socket.cpp
        tremotesf/ipc/ipcserver_socket.h
        tremotesf/startup/signalhandler_unix.cpp
        tremotesf/ui/darkthemeapplier_noop.cpp
        tremotesf/ui/notificationscontroller_fallback.cpp
        tremotesf/ui/systemcolorsprovider_noop.cpp
    )
endif()

if (WIN32)
    install(TARGETS tremotesf DESTINATION ".")
    if (MSVC)
        install(FILES $<TARGET_PDB_FILE:tremotesf> DESTINATION "." OPTIONAL)
    endif()
else()
    install(TARGETS tremotesf DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif()

set_common_options_on_targets()

=== translations/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2023 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS LinguistTools)
# Make sure to also change translations.qrc
qt_add_translation(qm_files
    en.ts
    es.ts
    fr.ts
    it_IT.ts
    nl_BE.ts
    nl.ts
    pl.ts
    ru.ts
    zh_CN.ts
)
add_custom_target(translations ALL DEPENDS ${qm_files})

configure_file(translations.qrc "${CMAKE_BINARY_DIR}" COPYONLY)
list(APPEND QRC_FILES "${CMAKE_BINARY_DIR}/translations.qrc")
set(QRC_FILES ${QRC_FILES} PARENT_SCOPE)

set(TREMOTESF_QT_TRANSLATIONS_FILENAME "qt")

if (WIN32)
    set(TREMOTESF_BUNDLED_QT_TRANSLATIONS_DIR "translations")
    set(TREMOTESF_BUNDLED_QT_TRANSLATIONS_DIR ${TREMOTESF_BUNDLED_QT_TRANSLATIONS_DIR} PARENT_SCOPE)

    # When we are building with dynamic Qt, we can use windeployqt which will automatically
    # merge all Qt translations in qt_*.qm and install with executable
    # When we are building with static Qt, windeployqt does not work
    # We then need to install translations ourselves, and since they are not merged
    # we install only qtbase_*.qm

    get_target_property(library_type Qt${TREMOTESF_QT_VERSION_MAJOR}::Core TYPE)
    if (library_type STREQUAL "STATIC_LIBRARY")
        message(STATUS "Building with static Qt, attempting to deploy Qt translations")
        find_file(qt_translations_dir "${CMAKE_INSTALL_DATADIR}/qt5/translations")
        if (qt_translations_dir)
            message(STATUS "Deploying Qt translations from ${qt_translations_dir}")
            set(TREMOTESF_QT_TRANSLATIONS_FILENAME "qtbase")
            install(DIRECTORY "${qt_translations_dir}" DESTINATION "." FILES_MATCHING PATTERN "${TREMOTESF_QT_TRANSLATIONS_FILENAME}_*.qm")
        else()
            message(WARNING "Qt transaltions not found")
        endif()
    endif()
endif()

set(TREMOTESF_QT_TRANSLATIONS_FILENAME ${TREMOTESF_QT_TRANSLATIONS_FILENAME} PARENT_SCOPE)

=== windows-packaging/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2023 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

set(CPACK_GENERATOR ZIP WIX)
set(CPACK_PACKAGE_NAME "Tremotesf")
set(CPACK_PACKAGE_VENDOR "Tremotesf")
set(CPACK_PACKAGE_EXECUTABLES "tremotesf;Tremotesf")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "Tremotesf")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/license.rtf")
set(CPACK_THREADS 0)

if (CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(CPACK_SYSTEM_NAME "win64")
else()
    set(CPACK_SYSTEM_NAME "win32")
endif()

set(package_suffix "")
get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if (is_multi_config)
    set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-${CPACK_SYSTEM_NAME}-\${CPACK_BUILD_CONFIG}")
else()
    set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-${CPACK_SYSTEM_NAME}-${CMAKE_BUILD_TYPE}")
endif()

set(CPACK_PACKAGE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

set(CPACK_WIX_UPGRADE_GUID "67e0511b-d9de-4b3c-a604-0dd47522d451")
set(CPACK_WIX_PRODUCT_ICON "${TREMOTESF_WINDOWS_ICON}")

set(CPACK_WIX_EXTRA_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/registry.wxs")
set(CPACK_WIX_PATCH_FILE "${CMAKE_CURRENT_SOURCE_DIR}/registry_feature_patch.wxs")

include(CPack)

=== src/libtremotesf/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2023 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

if (WIN32)
    cmake_minimum_required(VERSION 3.21)
else()
    cmake_minimum_required(VERSION 3.16)
endif()
cmake_policy(VERSION ${CMAKE_MINIMUM_REQUIRED_VERSION}..3.26)

option(TREMOTESF_QT6 "Build with Qt 6" ON)
if ((DEFINED VCPKG_TARGET_TRIPLET) AND (NOT DEFINED VCPKG_MANIFEST_FEATURES))
    if (TREMOTESF_QT6)
        set(VCPKG_MANIFEST_FEATURES qt6)
    else()
        set(VCPKG_MANIFEST_FEATURES qt5)
    endif()
endif()

project(libtremotesf CXX)

include(CTest)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

include(cmake/CommonOptions.cmake)

find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Core Concurrent Network)
find_package(fmt 7.0 REQUIRED)

if (WIN32 OR ANDROID)
    set(registrable_domain_qt ON)
else()
    set(registrable_domain_qt OFF)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(libpsl REQUIRED IMPORTED_TARGET libpsl)
endif()

add_library(
    libtremotesf
    OBJECT
    addressutils.cpp
    addressutils.h
    demangle.cpp
    demangle.h
    fileutils.cpp
    fileutils.h
    formatters.cpp
    formatters.h
    itemlistupdater.h
    jsonutils.h
    literals.h
    log.cpp
    log.h
    pathutils.cpp
    pathutils.h
    peer.cpp
    peer.h
    rpc.cpp
    rpc.h
    requestrouter.cpp
    requestrouter.h
    serversettings.cpp
    serversettings.h
    serverstats.cpp
    serverstats.h
    stdutils.h
    target_os.h
    torrent.cpp
    torrent.h
    torrentfile.cpp
    torrentfile.h
    tracker.cpp
    tracker.h
)

target_link_libraries(libtremotesf PUBLIC Qt::Core Qt::Network fmt::fmt)
if (registrable_domain_qt)
    target_compile_definitions(libtremotesf PRIVATE LIBTREMOTESF_REGISTRABLE_DOMAIN_QT)
else()
    target_link_libraries(libtremotesf PRIVATE PkgConfig::libpsl)
endif()
target_include_directories(libtremotesf PRIVATE ${Qt${TREMOTESF_QT_VERSION_MAJOR}Concurrent_INCLUDE_DIRS})

qt_import_plugins(libtremotesf EXCLUDE_BY_TYPE bearer)

if (BUILD_TESTING AND NOT ANDROID)
    find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Test)

    add_executable(itemlistupdater_test itemlistupdater_test.cpp)
    add_test(NAME itemlistupdater_test COMMAND itemlistupdater_test)
    target_link_libraries(itemlistupdater_test libtremotesf Qt::Test)

    add_executable(log_test log_test.cpp)
    add_test(NAME log_test COMMAND log_test)
    target_link_libraries(log_test libtremotesf Qt::Test)

    add_executable(demangle_test demangle_test.cpp)
    add_test(NAME demangle_test COMMAND demangle_test)
    target_link_libraries(demangle_test libtremotesf Qt::Test)

    # httplib requires same minor version for compatibility so setting minimum version as 0.11 won't work
    # We can work both with 0.11 and 0.12 so perform separate find_package calls for them
    find_package(httplib 0.12 QUIET)
    if (NOT httplib_FOUND)
        message(STATUS "Did not found cpp-httplib 0.12, trying 0.11")
        find_package(httplib 0.11 QUIET)
    endif()
    if (NOT httplib_FOUND)
        message(STATUS "Did not found cpp-httplib as a CMake package, trying pkg-config")
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(httplib IMPORTED_TARGET cpp-httplib>=0.11 cpp-httplib<=0.12)
    endif()
    if (NOT httplib_FOUND)
        message(STATUS "Using bundled cpp-httplib")
        set(HTTPLIB_REQUIRE_OPENSSL ON)
        add_subdirectory(3rdparty/cpp-httplib EXCLUDE_FROM_ALL)
    else()
        if (httplib_VERSION)
            message(STATUS "Using system cpp-httplib ${httplib_VERSION}")
        else()
            message(STATUS "Using system cpp-httplib")
        endif()
    endif()

    add_executable(requestrouter_test requestrouter_test.cpp)
    target_compile_definitions(requestrouter_test PRIVATE TEST_DATA_PATH="${CMAKE_CURRENT_SOURCE_DIR}/test-data" CPPHTTPLIB_OPENSSL_SUPPORT)
    add_test(NAME requestrouter_test COMMAND requestrouter_test)
    target_link_libraries(requestrouter_test libtremotesf Qt::Test)
    if (TARGET PkgConfig::httplib)
        target_link_libraries(requestrouter_test libtremotesf PkgConfig::httplib)
    else()
        target_link_libraries(requestrouter_test libtremotesf httplib::httplib)
    endif()

    add_executable(pathutils_test pathutils_test.cpp)
    add_test(NAME pathutils_test COMMAND pathutils_test)
    target_link_libraries(pathutils_test libtremotesf Qt::Test)

    add_executable(tracker_test tracker_test.cpp)
    add_test(NAME tracker_test COMMAND tracker_test)
    target_link_libraries(tracker_test libtremotesf Qt::Test)
endif()

set_common_options_on_targets()

=== src/libtremotesf/3rdparty/cpp-httplib/CMakeLists.txt ===
#[[
	Build options:
	* BUILD_SHARED_LIBS (default off) builds as a shared library (if HTTPLIB_COMPILE is ON)
	* HTTPLIB_USE_OPENSSL_IF_AVAILABLE (default on)
	* HTTPLIB_USE_ZLIB_IF_AVAILABLE (default on)
	* HTTPLIB_REQUIRE_OPENSSL (default off)
	* HTTPLIB_REQUIRE_ZLIB (default off)
	* HTTPLIB_USE_BROTLI_IF_AVAILABLE (default on)
	* HTTPLIB_REQUIRE_BROTLI (default off)
	* HTTPLIB_COMPILE (default off)
	* HTTPLIB_TEST (default off)
	* BROTLI_USE_STATIC_LIBS - tells Cmake to use the static Brotli libs (only works if you have them installed).
	* OPENSSL_USE_STATIC_LIBS - tells Cmake to use the static OpenSSL libs (only works if you have them installed).

	-------------------------------------------------------------------------------

	After installation with Cmake, a find_package(httplib COMPONENTS OpenSSL ZLIB Brotli) is available.
	This creates a httplib::httplib target (if found and if listed components are supported).
	It can be linked like so:

	target_link_libraries(your_exe httplib::httplib)

	The following will build & install for later use.

	Linux/macOS:

	mkdir -p build
	cd build
	cmake -DCMAKE_BUILD_TYPE=Release ..
	sudo cmake --build . --target install

	Windows:

	mkdir build
	cd build
	cmake ..
	runas /user:Administrator "cmake --build . --config Release --target install"

	-------------------------------------------------------------------------------

	These variables are available after you run find_package(httplib)
	* HTTPLIB_HEADER_PATH - this is the full path to the installed header (e.g. /usr/include/httplib.h).
	* HTTPLIB_IS_USING_OPENSSL - a bool for if OpenSSL support is enabled.
	* HTTPLIB_IS_USING_ZLIB - a bool for if ZLIB support is enabled.
	* HTTPLIB_IS_USING_BROTLI - a bool for if Brotli support is enabled.
	* HTTPLIB_IS_COMPILED - a bool for if the library is compiled, or otherwise header-only.
	* HTTPLIB_INCLUDE_DIR - the root path to httplib's header (e.g. /usr/include).
	* HTTPLIB_LIBRARY - the full path to the library if compiled (e.g. /usr/lib/libhttplib.so).
	* httplib_VERSION or HTTPLIB_VERSION - the project's version string.
	* HTTPLIB_FOUND - a bool for if the target was found.

	Want to use precompiled headers (Cmake feature since v3.16)?
	It's as simple as doing the following (before linking):

	target_precompile_headers(httplib::httplib INTERFACE "${HTTPLIB_HEADER_PATH}")

	-------------------------------------------------------------------------------

	FindPython3 requires Cmake v3.12
	ARCH_INDEPENDENT option of write_basic_package_version_file() requires Cmake v3.14
]]
cmake_minimum_required(VERSION 3.14.0 FATAL_ERROR)

# Get the CPPHTTPLIB_VERSION value and use it as a version
# This gets the string with the CPPHTTPLIB_VERSION value from the header.
# This is so the maintainer doesn't actually need to update this manually.
file(STRINGS httplib.h _raw_version_string REGEX "CPPHTTPLIB_VERSION \"([0-9]+\\.[0-9]+\\.[0-9]+)\"")

# Needed since git tags have "v" prefixing them.
# Also used if the fallback to user agent string is being used.
string(REGEX MATCH "([0-9]+\\.?)+" _httplib_version "${_raw_version_string}")

project(httplib VERSION ${_httplib_version} LANGUAGES CXX)

# Change as needed to set an OpenSSL minimum version.
# This is used in the installed Cmake config file.
set(_HTTPLIB_OPENSSL_MIN_VER "1.1.1")

# Allow for a build to require OpenSSL to pass, instead of just being optional
option(HTTPLIB_REQUIRE_OPENSSL "Requires OpenSSL to be found & linked, or fails build." OFF)
option(HTTPLIB_REQUIRE_ZLIB "Requires ZLIB to be found & linked, or fails build." OFF)
# Allow for a build to casually enable OpenSSL/ZLIB support, but silently continue if not found.
# Make these options so their automatic use can be specifically disabled (as needed)
option(HTTPLIB_USE_OPENSSL_IF_AVAILABLE "Uses OpenSSL (if available) to enable HTTPS support." ON)
option(HTTPLIB_USE_ZLIB_IF_AVAILABLE "Uses ZLIB (if available) to enable Zlib compression support." ON)
# Lets you compile the program as a regular library instead of header-only
option(HTTPLIB_COMPILE "If ON, uses a Python script to split the header into a compilable header & source file (requires Python v3)." OFF)
# Just setting this variable here for people building in-tree
if(HTTPLIB_COMPILE)
	set(HTTPLIB_IS_COMPILED TRUE)
endif()
option(HTTPLIB_TEST "Enables testing and builds tests" OFF)
option(HTTPLIB_REQUIRE_BROTLI "Requires Brotli to be found & linked, or fails build." OFF)
option(HTTPLIB_USE_BROTLI_IF_AVAILABLE "Uses Brotli (if available) to enable Brotli decompression support." ON)
# Defaults to static library
option(BUILD_SHARED_LIBS "Build the library as a shared library instead of static. Has no effect if using header-only." OFF)
if (BUILD_SHARED_LIBS AND WIN32 AND HTTPLIB_COMPILE)
	# Necessary for Windows if building shared libs
	# See https://stackoverflow.com/a/40743080
	set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

# Threads needed for <thread> on some systems, and for <pthread.h> on Linux
set(THREADS_PREFER_PTHREAD_FLAG true)
find_package(Threads REQUIRED)
# Since Cmake v3.11, Crypto & SSL became optional when not specified as COMPONENTS.
if(HTTPLIB_REQUIRE_OPENSSL)
	find_package(OpenSSL ${_HTTPLIB_OPENSSL_MIN_VER} COMPONENTS Crypto SSL REQUIRED)
elseif(HTTPLIB_USE_OPENSSL_IF_AVAILABLE)
	find_package(OpenSSL ${_HTTPLIB_OPENSSL_MIN_VER} COMPONENTS Crypto SSL QUIET)
endif()
# Just setting this variable here for people building in-tree
if(OPENSSL_FOUND)
	set(HTTPLIB_IS_USING_OPENSSL TRUE)
endif()

if(HTTPLIB_REQUIRE_ZLIB)
	find_package(ZLIB REQUIRED)
elseif(HTTPLIB_USE_ZLIB_IF_AVAILABLE)
	find_package(ZLIB QUIET)
endif()
# Just setting this variable here for people building in-tree
# FindZLIB doesn't have a ZLIB_FOUND variable, so check the target.
if(TARGET ZLIB::ZLIB)
	set(HTTPLIB_IS_USING_ZLIB TRUE)
endif()

# Adds our cmake folder to the search path for find_package
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
if(HTTPLIB_REQUIRE_BROTLI)
	find_package(Brotli COMPONENTS encoder decoder common REQUIRED)
elseif(HTTPLIB_USE_BROTLI_IF_AVAILABLE)
	find_package(Brotli COMPONENTS encoder decoder common QUIET)
endif()
# Just setting this variable here for people building in-tree
if(Brotli_FOUND)
	set(HTTPLIB_IS_USING_BROTLI TRUE)
endif()

# Used for default, common dirs that the end-user can change (if needed)
# like CMAKE_INSTALL_INCLUDEDIR or CMAKE_INSTALL_DATADIR
include(GNUInstallDirs)

if(HTTPLIB_COMPILE)
	# Put the split script into the build dir
	configure_file(split.py "${CMAKE_CURRENT_BINARY_DIR}/split.py"
		COPYONLY
	)
	# Needs to be in the same dir as the python script
	configure_file(httplib.h "${CMAKE_CURRENT_BINARY_DIR}/httplib.h"
		COPYONLY
	)

	# Used outside of this if-else
	set(_INTERFACE_OR_PUBLIC PUBLIC)
	# Brings in the Python3_EXECUTABLE path we can use.
	find_package(Python3 REQUIRED)
	# Actually split the file
	# Keeps the output in the build dir to not pollute the main dir
	execute_process(COMMAND ${Python3_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/split.py"
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
		ERROR_VARIABLE _httplib_split_error
	)
	if(_httplib_split_error)
		message(FATAL_ERROR "Failed when trying to split cpp-httplib with the Python script.\n${_httplib_split_error}")
	endif()

	# split.py puts output in "out"
	set(_httplib_build_includedir "${CMAKE_CURRENT_BINARY_DIR}/out")
	# This will automatically be either static or shared based on the value of BUILD_SHARED_LIBS
	add_library(${PROJECT_NAME} "${_httplib_build_includedir}/httplib.cc")
	target_sources(${PROJECT_NAME}
		PUBLIC
			$<BUILD_INTERFACE:${_httplib_build_includedir}/httplib.h>
			$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/httplib.h>
	)
	set_target_properties(${PROJECT_NAME}
		PROPERTIES
			VERSION ${${PROJECT_NAME}_VERSION}
			SOVERSION "${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR}"
	)
else()
	# This is for header-only.
	set(_INTERFACE_OR_PUBLIC INTERFACE)
	add_library(${PROJECT_NAME} INTERFACE)
	set(_httplib_build_includedir "${CMAKE_CURRENT_SOURCE_DIR}")
endif()
# Lets you address the target with httplib::httplib
# Only useful if building in-tree, versus using it from an installation.
add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

# Require C++11
target_compile_features(${PROJECT_NAME} ${_INTERFACE_OR_PUBLIC}
	cxx_std_11
)

target_include_directories(${PROJECT_NAME} SYSTEM ${_INTERFACE_OR_PUBLIC}
    $<BUILD_INTERFACE:${_httplib_build_includedir}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

# Always require threads
target_link_libraries(${PROJECT_NAME} ${_INTERFACE_OR_PUBLIC}
		Threads::Threads
		# Needed for Windows libs on Mingw, as the pragma comment(lib, "xyz") aren't triggered.
		$<$<PLATFORM_ID:Windows>:ws2_32>
		$<$<PLATFORM_ID:Windows>:crypt32>
		$<$<PLATFORM_ID:Windows>:cryptui>
		# Needed for API from MacOS Security framework
		"$<$<AND:$<PLATFORM_ID:Darwin>,$<BOOL:${HTTPLIB_IS_USING_OPENSSL}>>:-framework CoreFoundation -framework Security>"
		# Can't put multiple targets in a single generator expression or it bugs out.
		$<$<BOOL:${HTTPLIB_IS_USING_BROTLI}>:Brotli::common>
		$<$<BOOL:${HTTPLIB_IS_USING_BROTLI}>:Brotli::encoder>
		$<$<BOOL:${HTTPLIB_IS_USING_BROTLI}>:Brotli::decoder>
		$<$<BOOL:${HTTPLIB_IS_USING_ZLIB}>:ZLIB::ZLIB>
		$<$<BOOL:${HTTPLIB_IS_USING_OPENSSL}>:OpenSSL::SSL>
		$<$<BOOL:${HTTPLIB_IS_USING_OPENSSL}>:OpenSSL::Crypto>
)

# Set the definitions to enable optional features
target_compile_definitions(${PROJECT_NAME} ${_INTERFACE_OR_PUBLIC}
	$<$<BOOL:${HTTPLIB_IS_USING_BROTLI}>:CPPHTTPLIB_BROTLI_SUPPORT>
	$<$<BOOL:${HTTPLIB_IS_USING_ZLIB}>:CPPHTTPLIB_ZLIB_SUPPORT>
	$<$<BOOL:${HTTPLIB_IS_USING_OPENSSL}>:CPPHTTPLIB_OPENSSL_SUPPORT>
)

# CMake configuration files installation directory
set(_TARGET_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")

include(CMakePackageConfigHelpers)

# Configures the meta-file httplibConfig.cmake.in to replace variables with paths/values/etc.
configure_package_config_file("${PROJECT_NAME}Config.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
	INSTALL_DESTINATION "${_TARGET_INSTALL_CMAKEDIR}"
	# Passes the includedir install path
	PATH_VARS CMAKE_INSTALL_FULL_INCLUDEDIR
)

if(HTTPLIB_COMPILE)
	write_basic_package_version_file("${PROJECT_NAME}ConfigVersion.cmake"
		# Example: if you find_package(httplib 0.5.4)
		# then anything >= 0.5 and <= 1.0 is accepted
		COMPATIBILITY SameMinorVersion
	)
else()
	write_basic_package_version_file("${PROJECT_NAME}ConfigVersion.cmake"
		# Example: if you find_package(httplib 0.5.4)
		# then anything >= 0.5 and <= 1.0 is accepted
		COMPATIBILITY SameMinorVersion
		# Tells Cmake that it's a header-only lib
		# Mildly useful for end-users :)
		ARCH_INDEPENDENT
	)
endif()

# Creates the export httplibTargets.cmake
# This is strictly what holds compilation requirements
# and linkage information (doesn't find deps though).
install(TARGETS ${PROJECT_NAME}
	EXPORT httplibTargets
)

install(FILES "${_httplib_build_includedir}/httplib.h" TYPE INCLUDE)

install(FILES
		"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
		"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
		# Install it so it can be used later by the httplibConfig.cmake file.
		# Put it in the same dir as our config file instead of a global path so we don't potentially stomp on other packages.
		"${CMAKE_CURRENT_SOURCE_DIR}/cmake/FindBrotli.cmake"
	DESTINATION ${_TARGET_INSTALL_CMAKEDIR}
)

# NOTE: This path changes depending on if it's on Windows or Linux
install(EXPORT httplibTargets
	# Puts the targets into the httplib namespace
	# So this makes httplib::httplib linkable after doing find_package(httplib)
	NAMESPACE ${PROJECT_NAME}::
	DESTINATION ${_TARGET_INSTALL_CMAKEDIR}
)

if(HTTPLIB_TEST)
    include(CTest)
    add_subdirectory(test)
endif()

=== src/libtremotesf/3rdparty/cpp-httplib/test/CMakeLists.txt ===
find_package(GTest)

if(GTest_FOUND)
    if(NOT TARGET GTest::gtest_main AND TARGET GTest::Main)
	# CMake <3.20
        add_library(GTest::gtest_main INTERFACE IMPORTED)
        target_link_libraries(GTest::gtest_main INTERFACE GTest::Main)
    endif()
else()
    if(POLICY CMP0135)
        cmake_policy(SET CMP0135 NEW)
    endif()

    include(FetchContent)

    set(BUILD_GMOCK OFF)
    set(INSTALL_GTEST OFF)
    set(gtest_force_shared_crt ON)

    FetchContent_Declare(
        gtest
        URL https://github.com/google/googletest/archive/main.tar.gz
    )
    FetchContent_MakeAvailable(gtest)
endif()

add_executable(httplib-test test.cc)
target_compile_options(httplib-test PRIVATE "$<$<CXX_COMPILER_ID:MSVC>:/utf-8;/bigobj>")
target_link_libraries(httplib-test PRIVATE httplib GTest::gtest_main)
gtest_discover_tests(httplib-test)

execute_process(
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_LIST_DIR}/www www
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_LIST_DIR}/www2 www2
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_LIST_DIR}/www3 www3
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_LIST_DIR}/ca-bundle.crt ca-bundle.crt
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_LIST_DIR}/image.jpg image.jpg
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND_ERROR_IS_FATAL ANY
)

if(HTTPLIB_IS_USING_OPENSSL)
    find_program(OPENSSL_COMMAND
        NAMES openssl
        PATHS ${OPENSSL_INCLUDE_DIR}/../bin
        REQUIRED
    )
    execute_process(
        COMMAND ${OPENSSL_COMMAND} genrsa 2048
        OUTPUT_FILE key.pem
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMAND_ERROR_IS_FATAL ANY
    )
    execute_process(
        COMMAND ${OPENSSL_COMMAND} req -new -batch -config ${CMAKE_CURRENT_LIST_DIR}/test.conf -key key.pem
        COMMAND ${OPENSSL_COMMAND} x509 -days 3650 -req -signkey key.pem
        OUTPUT_FILE cert.pem
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMAND_ERROR_IS_FATAL ANY
    )
    execute_process(
        COMMAND ${OPENSSL_COMMAND} req -x509 -new -config ${CMAKE_CURRENT_LIST_DIR}/test.conf -key key.pem -sha256 -days 3650 -nodes -out cert2.pem -extensions SAN
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMAND_ERROR_IS_FATAL ANY
    )
    execute_process(
        COMMAND ${OPENSSL_COMMAND} genrsa 2048
        OUTPUT_FILE rootCA.key.pem
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMAND_ERROR_IS_FATAL ANY
    )
    execute_process(
        COMMAND ${OPENSSL_COMMAND} req -x509 -new -batch -config ${CMAKE_CURRENT_LIST_DIR}/test.rootCA.conf -key rootCA.key.pem -days 1024
        OUTPUT_FILE rootCA.cert.pem
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMAND_ERROR_IS_FATAL ANY
    )
    execute_process(
        COMMAND ${OPENSSL_COMMAND} genrsa 2048
        OUTPUT_FILE client.key.pem
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMAND_ERROR_IS_FATAL ANY
    )
    execute_process(
        COMMAND ${OPENSSL_COMMAND} req -new -batch -config ${CMAKE_CURRENT_LIST_DIR}/test.conf -key client.key.pem
        COMMAND ${OPENSSL_COMMAND} x509 -days 370 -req -CA rootCA.cert.pem -CAkey rootCA.key.pem -CAcreateserial
        OUTPUT_FILE client.cert.pem
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMAND_ERROR_IS_FATAL ANY
    )
    execute_process(
        COMMAND ${OPENSSL_COMMAND} genrsa -passout pass:test123! 2048
        OUTPUT_FILE key_encrypted.pem
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMAND_ERROR_IS_FATAL ANY
    )
    execute_process(
        COMMAND ${OPENSSL_COMMAND} req -new -batch -config ${CMAKE_CURRENT_LIST_DIR}/test.conf -key key_encrypted.pem
        COMMAND ${OPENSSL_COMMAND} x509 -days 3650 -req -signkey key_encrypted.pem
        OUTPUT_FILE cert_encrypted.pem
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMAND_ERROR_IS_FATAL ANY
    )
endif()

=== src/libtremotesf/3rdparty/cpp-httplib/test/Makefile ===
CXX = clang++
CXXFLAGS = -g -std=c++11 -I. -Wall -Wextra -Wtype-limits -Wconversion -Wshadow # -fno-exceptions -DCPPHTTPLIB_NO_EXCEPTIONS -fsanitize=address

PREFIX = /usr/local
#PREFIX = $(shell brew --prefix)

OPENSSL_DIR = $(PREFIX)/opt/openssl@1.1
#OPENSSL_DIR = $(PREFIX)/opt/openssl@3
OPENSSL_SUPPORT = -DCPPHTTPLIB_OPENSSL_SUPPORT -I$(OPENSSL_DIR)/include -L$(OPENSSL_DIR)/lib -lssl -lcrypto

ifneq ($(OS), Windows_NT)
	UNAME_S := $(shell uname -s)
	ifeq ($(UNAME_S), Darwin)
		OPENSSL_SUPPORT += -framework CoreFoundation -framework Security
	endif
endif

ZLIB_SUPPORT = -DCPPHTTPLIB_ZLIB_SUPPORT -lz

BROTLI_DIR = $(PREFIX)/opt/brotli
BROTLI_SUPPORT = -DCPPHTTPLIB_BROTLI_SUPPORT -I$(BROTLI_DIR)/include -L$(BROTLI_DIR)/lib -lbrotlicommon -lbrotlienc -lbrotlidec

TEST_ARGS = gtest/gtest-all.cc gtest/gtest_main.cc $(OPENSSL_SUPPORT) $(ZLIB_SUPPORT) $(BROTLI_SUPPORT) -pthread

# By default, use standalone_fuzz_target_runner.
# This runner does no fuzzing, but simply executes the inputs
# provided via parameters.
# Run e.g. "make all LIB_FUZZING_ENGINE=/path/to/libFuzzer.a"
# to link the fuzzer(s) against a real fuzzing engine.
# OSS-Fuzz will define its own value for LIB_FUZZING_ENGINE.
LIB_FUZZING_ENGINE ?= standalone_fuzz_target_runner.o

all : test test_split
	./test

proxy : test_proxy
	./test_proxy

test : test.cc include_httplib.cc ../httplib.h Makefile cert.pem
	$(CXX) -o $@ -I.. $(CXXFLAGS) test.cc include_httplib.cc $(TEST_ARGS)

# Note: The intention of test_split is to verify that it works to compile and
# link the split httplib.h, so there is normally no need to execute it.
test_split : test.cc ../httplib.h httplib.cc Makefile cert.pem
	$(CXX) -o $@ $(CXXFLAGS) test.cc httplib.cc $(TEST_ARGS)

test_proxy : test_proxy.cc ../httplib.h Makefile cert.pem
	$(CXX) -o $@ -I.. $(CXXFLAGS) test_proxy.cc $(TEST_ARGS)

# Runs server_fuzzer.cc based on value of $(LIB_FUZZING_ENGINE).
# Usage: make fuzz_test LIB_FUZZING_ENGINE=/path/to/libFuzzer
fuzz_test: server_fuzzer
	./server_fuzzer fuzzing/corpus/*

# Fuzz target, so that you can choose which $(LIB_FUZZING_ENGINE) to use.
server_fuzzer : fuzzing/server_fuzzer.cc ../httplib.h standalone_fuzz_target_runner.o
	$(CXX) -o $@ -I.. $(CXXFLAGS) $< $(OPENSSL_SUPPORT) $(ZLIB_SUPPORT) $(BROTLI_SUPPORT) $(LIB_FUZZING_ENGINE) -pthread

# Standalone fuzz runner, which just reads inputs from fuzzing/corpus/ dir and
# feeds it to server_fuzzer.
standalone_fuzz_target_runner.o : fuzzing/standalone_fuzz_target_runner.cpp
	$(CXX) -o $@ -I.. $(CXXFLAGS) -c $<

httplib.cc : ../httplib.h
	python3 ../split.py -o .

cert.pem:
	openssl genrsa 2048 > key.pem
	openssl req -new -batch -config test.conf -key key.pem | openssl x509 -days 3650 -req -signkey key.pem > cert.pem
	openssl req -x509 -config test.conf -key key.pem -sha256 -days 3650 -nodes -out cert2.pem -extensions SAN
	openssl genrsa 2048 > rootCA.key.pem
	openssl req -x509 -new -batch -config test.rootCA.conf -key rootCA.key.pem -days 1024 > rootCA.cert.pem
	openssl genrsa 2048 > client.key.pem
	openssl req -new -batch -config test.conf -key client.key.pem | openssl x509 -days 370 -req -CA rootCA.cert.pem -CAkey rootCA.key.pem -CAcreateserial > client.cert.pem
	openssl genrsa -passout pass:test123! 2048 > key_encrypted.pem
	openssl req -new -batch -config test.conf -key key_encrypted.pem | openssl x509 -days 3650 -req -signkey key_encrypted.pem > cert_encrypted.pem
	#c_rehash .

clean:
	rm -f test test_split test_proxy server_fuzzer *.pem *.0 *.o *.1 *.srl httplib.h httplib.cc

=== debian/changelog ===
tremotesf (2.4.0-1) unstable; urgency=medium

  * Initial packaging (Closes: #1053805)

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 11 Oct 2023 12:03:24 -0400

=== debian/control ===
Source: tremotesf
Maintainer: Antoine Beaupré <anarcat@debian.org>
Section: net
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-cmake,
               dh-cmake-compat (= 1),
               dh-sequence-cmake,
               dh-sequence-ctest,
               gettext,
               libcpp-httplib-dev,
               libcxxopts-dev,
               libfmt-dev,
               libkf5widgetsaddons-dev,
               libkf5windowsystem-dev,
               libpsl-dev,
               libssl-dev,
               ninja-build,
               pkgconf,
               qtbase5-dev,
               qttools5-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/equeim/tremotesf2

Package: tremotesf
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Suggests: transmission-daemon,
Description: Remote GUI for transmission-daemon
 Tremotesf is yet another, but modern (first-released in 2016)
 cross-platfom GUI for Transmission daemon written in C++ and Qt.
 .
 Features include, but not necessarily limited to:
  * View torrent list
  * Sort torrents
  * Filter torrents by name, status and trackers
  * Start/stop/verify/remove torrents with multi-selection
  * Add torrents from torrent files and magnet links
  * Select which files to download when adding torrent
  * Manage torrent files
  * Add and remove torrent trackers
  * View torrent peers
  * Set torrent limits
  * Change remote server settings
  * View server statistics
  * Multiple servers
  * Supports HTTPS connection
  * Can connect to servers with self-signed certificates (you need to add
    certificate to server settings)
  * Client certificate authentication
